-- Author       : Jean-Pierre Dareys Robertson
-- Date         : 080415
--
-- Notes        : This query will report free space left on all
--                devices in a 15.x server regardless of configured
--                page size.
--
-- Updates      : 130207
--                converted into stored procedure.  
 
USE sybsystemprocs
GO
 
CREATE PROCEDURE sp_generic_device_free_space 
AS         
SELECT
  device_name           = d.name
, size_in_MB            = (high - low + 1) / (power(1024,2) / @@pagesize)
, free_space_in_MB      = 
 
  isnull(
 
  ( (high - low + 1) / (power(1024,2) / @@pagesize) ) -
 
   (SELECT sum(u.size) / (power(1024,2) / @@maxpagesize) FROM master..sysusages u
    WHERE  u.vstart between d.low and d.high
    AND    u.vdevno = d.vdevno
    GROUP BY d.vdevno)
 
, ( (high - low + 1) / (power(1024,2) / @@pagesize) ) 
 
  )
 
FROM
   master..sysdevices d
WHERE
   d.cntrltype = 0
GO